{{
********************************************
*  DE2-115 FPGA P1V : 5 x Propeller demo   *
********************************************

Propeller #2 I/O assignments

7 segemnt displays x 4

  pa6..0        hex3[6..0]
  pa13..7       hex2[6..0]
  pa20..14      hex1[6..0]
  pa27..21      hex0[6..0]

}}
con

  _clkmode = xtal1 + pll16x
  _clkfreq = 120_000_000

var

  long  mystack[10]
  
pub main

'1,3,4,5 dead/broken @140 MHz
'7 @ 133 MHz cog 7 runs faster?
'@120 Mhz all ok

  coginit(7,p2_test,@mystack)

  repeat
  
pub p2_test|x,q,d,z,t
     
  dira := $fffffff

  x~
  repeat
    z := 1000
    q := x
    d~
      repeat 4
          t := q / z
          d <<= 7
          d |= convert(t)
          q -= (t * z)
          z /= 10
      
      outa := d
      waitcnt(cnt + clkfreq / 10)
      x++
      if x == 10000
         x~
         
pub convert(v)

  result := 127 - lookupz(v:63,6,91,79,102,109,125,7,127,111,119,124,88,94,121,113)

pub dummy

  repeat
      