{{
********************************************
*  DE2-115 FPGA P1V : 5 x Propeller demo   *
********************************************

Propeller #1 I/O assignments

7 segemnt displays

  pa6..0        hex5[6..0]
  pa13..7       hex4[6..0]

IR dtector

  pa16          IRDA_RXD
    
}}

con

  _clkmode = xtal1 + pll16x
  _clkfreq = 120_000_000

var

  long  mystack[10]

pub main

'1,2,4,5,6 dead? @ 140MHz

  coginit(7,p1_test,@mystack)
  repeat
    
pub p1_test|x

  x~
  dira := $3fff
  update(5)
  
  repeat
    if ina[16] == 0   'ir detector
       x++
       update(x)

pub update(x)|q,d
       
      x &= $ff
      q := convert(x >> 4)
      d := q << 7
      q := convert(x & $f)
      d |= q
      outa := d
      waitcnt(cnt + constant(133_000_000 /10))
    
pub convert(v)

  result := 127 - lookupz(v:63,6,91,79,102,109,125,7,127,111,119,124,88,94,121,113)

pub dummy

  repeat
        