{{
********************************************
*  DE2-115 FPGA P1V : 5 x Propeller demo   *
********************************************

Propeller #3 I/O assignments

8 x red leds and switches - test INA function

  pa7..0       ledr[7..0]
  pa15..8      sw[7..0]
  
}}

  _clkmode = xtal1 + pll16x
  _clkfreq = 120_000_000

var

  long  mystack[10]
  
pub main

  coginit(3,p3_test,@mystack)
  repeat
  
pub p3_test|x

  dira := $ff

  x := 1
  repeat

     repeat while (ina >> 8) & $ff
        outa := ina >> 8

    repeat 7
      x <<= 1
      outa := x
      waitcnt(cnt + clkfreq >> 2)
    
    repeat 7
      x >>= 1
      outa := x
      waitcnt(cnt + clkfreq >> 2)
    
    